#!/usr/bin/perl

sub fnd_make{
  local( $typ ) = @_;

  $myfnd = ".MT_myfnddr";
  $myfnd = ".MT_myfndfl" if( $typ eq "f" );
  $tnow  = time;
  if( -f $myfnd ){
    $ftim = &timinod($myfnd, "c");
    $dtim = $tnow - $ftim;
    if( $dtim < 3600 ){
      $msg = int($dtim/60) . " minutes ago"; }
    elsif( $dtim < (24*3600) ){
      $msg = int($dtim/3600) . " hours ago"; }
    else{
      $msg = int($dtim/(24*3600)) . " days ago"; }
    print "  Use Find-file created " . $msg ." ? (<rtn>:y/n) ==> ";
    $ans = <STDIN>;
    chomp($ans);
    goto LB100 if( "$ans" eq "y" || "$ans" eq "" );
  }

  print " Executing find-command.\n";
  $pwd = `pwd`;
  chomp($pwd);
  open(FTMP,"find $pwd -type $typ -print |");

  open(FILE,"> $myfnd");
  $opt = 1;
  while(<FTMP>){
    $line = $_;
    $ii++;
    printf FILE "%1d %s", $opt, $line;
  }
  close(FTMP);
  close(FILE);

LB100:
$myfnd;
}
1;

sub fnd_read{
  local ($file) = @_;
  local ($i, $nmax);

  @fnd_opt = ();
  @fnd_nam = ();

  $ii = 0;
  open(FILE,"$file");
  while(<FILE>){
    $line = $_;
    chomp($line);
    $opt = substr($line, 0, 1);
    $ii++ if($opt == 1);
    push( @fnd_opt, $opt );
    push( @fnd_nam, substr($line, 2));
  }   
  $nact = $ii;

  $mesg = "files"       if($typ eq "f");
  $mesg = "directories" if($typ eq "d");
  $nmax = $#fnd_nam+1;
  $pwd  = `pwd`;
  chomp($pwd);
  $ftim = &timinod($myfnd, "c");
  $ftim = &timjpn($ftim);
  print "\n";
  print "  [$myfnd] made at $ftim\n";
  print "    contains $nact-active $mesg  (total $nmax) in $pwd\n";

  if( $nact != $nmax ){
    print "\n";
    if( $nact == 0 ){
      print "  No acitive $mesg.  So clear flag.\n";
      print "  enter any key ==> ";
      $ans = <STDIN>;
    }
    else{
      print ">> clear flag ? (y/n:<rtn>) ==> ";
      $ans = <STDIN>;
      chomp($ans);
      goto LB150 if( "$ans" eq "n" || "$ans" eq "" );
    }
    for($i=0; $i<$nmax; $i++){
      $fnd_opt[$i] = 1; }
    $nact = $nmax;
  }

  LB150:
  $err = 0;
  $ii = 0;
  for($i=0; $i<$nmax; $i++){
    $opt = $fnd_opt[$i];
    next if( $opt == 0 );
    $nam = $fnd_nam[$i];
    $fnd_opt[$i] = $opt;    
    $ii++ if( $fnd_opt[$i] == 1 ); }

  $nact = $ii;
  print "    contains $nact-active $mesg  (total $nmax) in $pwd\n";

  return;
  LB190:
  print "   Too many error.  Please make New-find file.\n";
  exit;
}
1;

sub fnd_time{
local ($i, $nmax);
LB100:
  print ">> enter date (2002_3_5/<rtn>:now/quit) ==> ";
  $ans = <STDIN>;
  chomp($ans);
  goto LB190 if( $ans =~ /^q/ );
  $utim1 = "xxx";
  $utim1 = &timunx($ans) if( index($ans,"_") > 0 );
  $utim1 = time  if( "$ans" eq "" );
  if( $utim1 eq "xxx" ){
    print "  Invalid input [$ans]\n";
    goto LB100; }
LB150:
  print ">> enter date (2002_5_31/60d/-2d/-5h/-15m/q) ==> ";
  $ans = <STDIN>;
  chomp($ans);
  $utim2 = "xxx";
  $utim2 = &timunx($ans) if( index($ans,"_") > 0 );
  $utim2 = time  if( "$ans" eq "" );
  if( $ans =~ /[dhm]$/ && $ans =~ /^[+-0123456789]/ ){
    $m = length($ans);
    $tunt = substr($ans,$m-1,1);
    $tval = substr($ans,0,$m-1);
    $tsec = 24*3600;
    $tsec = 3600 if( $tunt eq "h" );
    $tsec = 60   if( $tunt eq "m" );
    $utim2 = $utim1 + $tval*$tsec; }
  if( $utime eq "xxx" ){
    print "  Ibvalid input [$ans]\n";
    goto LB150; }

  $jtim1 = &timjpn($utim1);
  $jtim2 = &timjpn($utim2);
  print "  date_1 = $jtim1  $utim1\n";
  print "  date_2 = $jtim2  $utim2\n";
  $dsec = $utim2 - $utim1;
  $dsec = -$dsec if( $dsec < 0 );
  if( $dsec < 60 ){
     $tunt = sec;
     $diff = $dsec; }
  elsif( $dsec < 3600 ){
     $tunt = min;
     $diff = int($dsec/60); }
  elsif( $dsec < 3600*24 ){
     $tunt = hours;
     $diff = int($dsec/3600); }
  else{
     $tunt = day;
     $diff = int($dsec/(24*3600)); }
  print "  diff   = $diff $tunt\n";

  $nmax = $#fnd_nam+1;
  for($i=0; $i<$nmax; $i++){
    $opt = $fnd_opt[$i];
    next if( $opt == 0 );
    $nam = $fnd_nam[$i];

    $utim = &timinod( $nam, "m" );
    $opt = 0 if( ($utim-$utim1)*($utim-$utim2) > 0 );

    $fnd_opt[$i] = $opt;
  }
  return;

LB190:
  print "  Command [fnd_time] was terminated.\n";
}
1;

sub fnd_write{
  local ($file) = @_;
  local ($i, $nmax);
  print "\n";
  print " write find-data to $file\n";
  $ii = 0;
  open(FILE,"> $file");
  $nmax = $#fnd_nam+1;
  for($i=0; $i<$nmax; $i++){
    $opt = $fnd_opt[$i];
    $ii++ if( $opt == 1 );
    printf FILE "%1d %s\n", $fnd_opt[$i], $fnd_nam[$i];
  }
  close(FILE);
}
1;

sub fnd_name{
  local ($i, $nmax);
  print ">> enter top name (mon/<rtn>:quit) ==> ";
  $top = <STDIN>;
  chomp($top);
  return if( "$top" eq "" );
  $nmax = $#fnd_nam+1;
  for($i=0; $i<$nmax; $i++){
    $opt = $fnd_opt[$i];
    next if($opt == 0);
    $m = rindex( $fnd_nam[$i], "/" );
    $nam = substr( $fnd_nam[$i], $m+1 );
    $fnd_opt[$i] = 0 unless( $nam =~ /^$top/ );
  }
}
1;
    
sub fnd_list{
  local ($i, $nmax);
  $nmax = $#fnd_nam+1;
  print ">> enter type (f:full/t:time/n:name/m:mother-dir/q) ==> ";
  $ans = <STDIN>;
  chomp($ans);  
  if( $ans =~ /^f/ ){
    $ii = 0;
    for($i=0; $i<$nmax; $i++){
      next if( $fnd_opt[$i] == 0 );
      $ii++;
      $nam  = $fnd_nam[$i];
      printf "  %2d  %s\n", $ii, $nam;
      if( $ii % $max_line == 0 ){
        print "  [$ii/$nact]  continue ? (<rtn>:y/q) ==> ";
        $ans = <STDIN>;
        chomp( $ans );
        last if( $ans =~ /^q/ ) }
    }
  }
  elsif( $ans =~ /^t/ ){
    $ii = 0;
    for($i=0; $i<$nmax; $i++){
      next if( $fnd_opt[$i] == 0 );
      $ii++;
      $nam  = $fnd_nam[$i];
      $utim = &timinod( $nam, "m" );
      $jtim = &timjpn( $utim );
      $jtim = substr( $jtim, 2, 8 );
      printf "  %2d  %s  %s\n", $ii, $jtim, $nam;
      if( $ii % $max_line == 0 ){
        print "  [$ii/$nact]  continue ? (<rtn>:y/q) ==> ";
        $ans = <STDIN>;
        chomp( $ans );
        last if( $ans =~ /^q/ ) }
    }
  }
  elsif( $ans =~ /^n/ ){
    @tblnm = ();
    $ii = 0;
    for($i=0; $i<$nmax; $i++){
      next if( $fnd_opt[$i] == 0 );
      $ii++;
      $nam = $fnd_nam[$i];
      $m   = rindex($nam,"/");
      push( @tblnm, substr($nam,$m+1) ); }
    if( $ii < 50 ){
      $MT_lnstr = 12;
      $MT_ncolm =  6;
      $MT_lnfix =  1;
      &pvlst(@tblnm); }
    else{
      &inq_name; }
  }
  elsif( $ans =~ /^m/ ){
    $lev = 1;
    $lev = substr( $ans, 1 ) if( length($ans) > 1 );
    @tbldr = ();
    for($i=0; $i<$nmax; $i++){
      next if( $fnd_opt[$i] == 0 );
      $nam = $fnd_nam[$i];
      $mdr = &pmdir($nam, $lev);
      next if( length($mdr) <= 0 );
      push( @tbldr, $mdr ); }
    @tbldr = &puniq(@tbldr);
    $ii = $#tbldr;
    print "  mother-level = $lev  number of dir = $ii\n";
    if( $ii < 50 ){
      $i = 0;
      foreach $mdr (@tbldr){
        $i++;
        printf "  %2d  %s\n", $i, $mdr; } }
  else{
	print "  raise mother-level   type m2\n"; }
  }
}
1;

sub fnd_actv{
  local ($i, $nmax);
  $nmax = $#fnd_nam+1;
  $ii = 0;
  for($i=0; $i<$nmax; $i++){
    $ii++ if( $fnd_opt[$i] == 1 ); }
  $no = $ii;
  print "  contains $no-active $mesg  (total:$nmax)\n";
  $no;
}
1;

sub fnd_help{
  print "\n";
  print " ===  COMMAND =================================\n";
  print "  t : specified time.\n";
  print "  n : specified name of file or dir.\n";
  print "  m : specified name of mother directory.\n";
  print "  e : specified extention of file.\n";
  print "  l : list of selected files or dir.\n";
  print "  r : read Find-file.\n";
  print "  g : grep command.\n";
  print "  s : show(Not edit) selected files.\n";
  print "  q : quit.\n";
  print "  h : help (print command)\n";
}
1;

sub fnd_show{
  local ($i, $nmax, $cnt, $nam, $temp);

  if( $mesg =~ "dir" ){
  print ">> enter contents of ls (<rtn>:dtf/t/td) ==> ";
  $cnt = <STDIN>;
  chomp($cnt);
  $cnt = "dtf" if( "$cnt" eq "" );
  $nmax = $#fnd_nam+1;
  for($i=0; $i<$nmax; $i++){
    next if( $fnd_opt[$i] == 0 );
    $nam = $fnd_nam[$i];
    print "\n";
    print "  check this dir ? [$nam]]\n";
    print "    (<rtn>:y/n/q ) ==> ";
    $ans = <STDIN>;
    chomp($ans);
    return if( $ans =~ /^q/ );
    next   if( $ans =~ /^n/ );
    next   unless( -d $nam );
    system( "cd $nam && $MT_plib/pls.pl $cnt" );
  }
  }

  if( $mesg =~ "file" ){
  LB100:
  $nmax = $#fnd_nam+1;
  open(FDSP,"> $MT_ftemp");
  print FDSP "### enter [1] at the head of line ###\n";
  for($i=0; $i<$nmax; $i++){
    next if( $fnd_opt[$i] == 0);
    $nam = $fnd_nam[$i];
    next unless( -T $nam );
    printf FDSP "   %s\n", $nam;
  }
  close(FDSP);
  system("perl $MT_plib/pdsp.pl  $MT_ftemp");
  print ">> show another files (<rtn>:y/n:quit) ==> ";
  $ans = <STDIN>;
  chomp($ans);
  goto LB100 if( "$ans" eq "" || "$ans" eq "y" );
  }
 }
1;

sub fnd_mdir{
  local ($i, $nmax);
  print ">> enter top name of m-dir (wkdr/<rtn>:quit) ==> ";
  $top = <STDIN>;
  chomp($top);
  return if( "$top" eq "" );
  $nmax = $#fnd_nam+1;
  for($i=0; $i<$nmax; $i++){
    $opt = $fnd_opt[$i];
    next if( $opt == 0 );
    $nam = $fnd_nam[$i];
    $m = rindex( $nam, "/" );
    $nam = substr( $nam, 0, $m );
    $m = rindex( $nam, "/" );
    if( $m <= 0 ){
      $fnd_opt[$i] = 0;
      next; }
    $nam = substr( $nam, $m+1 );
    $fnd_opt[$i] = 0 unless( $nam =~ /^$top/ );
  }
}
1;

sub fnd_ext{
  local ($i, $nmax, $opt, $ext, $nam, $m, $flg);
  print ">> enter extension (f/c/tar/<rtn>:quit) ==> ";
  $ext = <STDIN>;
  chomp($ext);
  return if( "$ext" eq "");
  $nmax = $#fnd_nam+1;
  for($i=0; $i<$nmax; $i++){
    $opt = $fnd_opt[$i];
    next if( $opt == 0 );
    $nam = $fnd_nam[$i];
    $m = rindex( $nam, "/" );
    $nam = substr( $nam, $m+1 );
    $m = rindex( $nam, "." );
    $flg = 0;
    $flg = 1 if( substr($nam,$m+1) eq $ext );
    $fnd_opt[$i] = $flg;
  }
}
1;

sub fnd_grep{
  local ($i, $nmax, $inp, $comd, $prmp, $mod);

  if( $mesg =~ "dir" ){
  print "  Do not use this command (grep) for dir.\n";
  return; }

  $prmp = int($nact/5);
  $prmp = int($prmp/10)*10;
  $prmp = 30 if( $prmp < 30 );
  $mod  = int($nact/200);
  $mod  = int($mod/10)*10;
  $mod  = 1 if( $mod < 1 );

  print ">> enter input of grep (aimas) ==> ";
  $inp = <STDIN>;
  chomp($inp);
  return if( "$inp" eq "" );

  $ii = 0;
  $nmax = $#fnd_nam+1;
  for($i=0; $i<$nmax; $i++){
    $opt = $fnd_opt[$i];
    next if( $opt == 0 );
    $nam = $fnd_nam[$i];
    unless( -T $nam ){
      $fnd_opt[$i] = 0;
      next; }
    $ii++;

    if( $inp =~ "-w" ){
      system("$MT_plib/plk.pl $inp $nam > $MT_ftemp");
      $no = `grep -c . $MT_ftemp`;
      $no = $no - 1; }
    else{
      system("grep $inp $nam > $MT_ftemp");
      $no = `grep -c . $MT_ftemp` }

##    if( $no > 0 ){
##      system("cat $MT_ftemp"); }

    $fnd_opt[$i] = 0 if( $no == 0 );
    if( $ii % $mod == 0 || $no > 0 ){
      printf " %5d %3d  %s\n", $ii, $no, $nam; }
    if( $ii % $prmp == 0 ){
      print "  [$ii/$nact]  continue ? (<rtn>:y/q) ==> ";
      $ans = <STDIN>;
      chomp($ans);
      last if( $ans =~ /^q/ ); }
  }
}
1;
