#!/usr/bin/perl

$perl = $ENV{"PERL"};
push( @INC, "$perl" );

local( $file, $rsta, $nfrd, $nfwt, @parm );
local( $fnew, $newp, $nam, $val );

### User option ###
$file = "inppls";   # namelist
@parm = ( "mxcpu", "itend", "flxni", "pfmag(1)", "rcy_al" );
                    # name of important variables in namelist

## If no use restart, $rsta ==> ##$rsta (comment)
$rsta = "dtprf_";   # restart file name
$nfrd = "cftr";     # name of read-file in namelist
$nfwt = "cftw";     # name of write-file in namelist
if( $rsta ){ @parm = ( @parm, "$nfrd",  "$nfwt" ); }

$fnew = "$file" . "_new";

### Library (Tips) ###
  require "pfsfx.pl";
  require "pgtvl.pl";
  require "pspltv.pl";
  require "pbspc.pl";
  require "pinp.pl";
  require "plast.pl";

### restart file ###
  $newf = "";
  if( $rsta ){
  $no   = &pfsfx($rsta);
  $no1  = $no + 1;
  $flr  = "$rsta$no";
  $flw  = "$rsta$no1";

  print ">> enter  read-rst file (<rtn>:$flr/spc:ini-cal) ==> ";
  $ans = <STDIN>;
  chomp($ans);
  $flr = $ans if( "$ans" ne "" );
  if( substr($flr,0,1) ne " " ){
    print "     start calculation from $flr\n"; }
  else{
    $flr = "  xxx";
    print "  initial calculation\n"; }
  $newf = $newf . "$nfrd = \"" . "$flr" . "\"";
  print ">> enter write-rst file (<rtn>:$flw/" . "$rsta" . "07) ==> ";
  $ans = <STDIN>;
  chomp($ans);
  $flw = $ans if( "$ans" ne "" );
  $flw = "  xxx" if( "$ans" eq " " );
  $newf = $newf . ",  $nfwt = \"" . "$flw" . "\",";
  print "     restart file [$newf]\n";
  }

### parameter survey (numerical value)###
  print "\n";
  print "  name     = default when <rtn>\n";
  print "-" x 50 . "\n";
  $newp = "";
  foreach $nam (@parm){
    next if( $nam eq $nfrd || $nam eq $nfwt );
    $val = &pgtvl($nam,$file);
    printf "  %-8s = %-8s    >> enter (<rtn>/new-V) ==> ", $nam, $val;
    $ans = <STDIN>;
    chomp($ans);
    if( $ans ne "" ){
      $newp = $newp . "  $nam = $ans,"; }
  }

  if( length($newp) == 0 ){
    $newp = "  ";
    print "  No changed parameter.\n"; }

  if( length(newf) > 0 ){
    $newp = $newf . "  " . $newp; }

### new input file ###
  &pinp( "$newp", $file, $fnew );

### confirmation of parameter ###
  print "\n";
  print "*** New parameter ***\n";
  foreach $nam (@parm){
    $val = &pgtvl($nam,$fnew);  
     printf "  %-8s = %-8s\n", $nam, $val; }
  print "\n";
  LB100:
  print " input data O.K.  (y/n) ==> ";
  $ans = <STDIN>;
  chomp($ans);
  if( "$ans" ne "y" && "$ans" ne "n" ){
    print "     Please answer y or n.\n";
    goto LB100; }
  if( "$ans" eq "n" ){
    print "  Command was canceled.\n";
    exit; }


### check New input file ###
  print "\n";
  print "New input data [$fnew]\n";
  print "-" x 80 . "\n";
  system("cat $fnew");
  print "-" x 80 . "\n";
  print "\n";

  print "Old input data [$file]\n";
  print "New input data [$fnew]\n";
  print "If you want to check,  diff -w $fnew $file\n";
  print "\n";

### your submit shell ###
##system("csh submit-shell");
  print "Submit job\n";
